#pragma once
/// <summary>
/// c#еί
/// </summary>
#include "object.h"

namespace framework
{
	namespace unity
	{
		class TNullType{};
	#pragma region ί
		enum DelegateType
		{  
			DT_MemberMethod = 1,   //Ա
			DT_StaticFunciton = 2, //̬
		};
	#pragma endregion

	#pragma region ίлģ
		template<typename SenderT/*¼*/, typename ParamT/*¼*/>
		class delegate : public unity::object
		{
		public:
			virtual ~delegate(){}
		#pragma region ӿ
			virtual DelegateType type() const = 0;	// ί
			virtual void operator()(SenderT sender, ParamT param) = 0;	// زʵίеĵ
			virtual bool operator==(const delegate& othd) = 0;	// ȽίǷ
			virtual delegate* clone() = 0;	// ¡ίж
		#pragma endregion
		};
	#pragma endregion

	#pragma region Աίģ
		template<typename RecObjT/*¼߶*/, typename RecMethodT/*¼߳Ա*/, typename SenderT, typename ParamT>  
		class delegate_mm : public delegate<SenderT, ParamT>
		{
		public:
			typedef delegate<SenderT, ParamT> SuperT;
			typedef delegate_mm<RecObjT, RecMethodT, SenderT, ParamT> ThisT;
			delegate_mm(const RecObjT& pObj, RecMethodT pMemFn)
				: mReceiverObject(pObj), mReceiverMemberMethod(pMemFn){}
			virtual ~delegate_mm(){}
		#pragma region ӿʵ
			virtual DelegateType type() const{ return DT_MemberMethod; }
			virtual void operator()(SenderT sender, ParamT param)
			{
				((*mReceiverObject).*mReceiverMemberMethod)(sender, param);
			}
			virtual SuperT* clone()
			{
				return new ThisT(mReceiverObject, mReceiverMemberMethod);
			}
			virtual bool operator==(const SuperT& othd)
			{
				if(othd.type() != DT_MemberMethod)
					return false;
				const ThisT& rFun = dynamic_cast<const ThisT&>(othd);
				return (mReceiverObject == rFun.mReceiverObject && mReceiverMemberMethod == rFun.mReceiverMemberMethod);
			}
		#pragma endregion
		protected:
		#pragma region Ա
			RecObjT mReceiverObject;			//¼߶
			RecMethodT mReceiverMemberMethod;	//¼Ա
		#pragma endregion
		};  
	#pragma endregion
	
	#pragma region ̬ȫֺίģ
		template <typename FuncT, typename SenderT, typename ParamT>
		class delegate_sf : public delegate<SenderT, ParamT>
		{
		public:
			typedef delegate<SenderT, ParamT> SuperT;
			typedef delegate_sf<FuncT, SenderT, ParamT> ThisT;
			delegate_sf(const FuncT& func) : mFunction(func){}
			virtual ~delegate_sf(){}
	#pragma region ӿʵ
			virtual DelegateType type() const{ return DT_StaticFunciton; }
			virtual void operator()(SenderT sender, ParamT param)
			{
				(*mFunction)(sender, param);
			}
			virtual SuperT* clone()
			{
				return new ThisT(mFunction);
			}
			virtual bool operator==(const SuperT& othd)
			{
				if(othd.type() != DT_StaticFunciton)
					return false;
				const ThisT& rFun = dynamic_cast<const ThisT&>(othd);
				return mFunction == rFun.mFunction;
			}
	#pragma endregion
		protected:
	#pragma region Ա
			FuncT mFunction;
	#pragma endregion
		};
	#pragma endregion
	}	// namespace unity
}	// namespace framework