#pragma once
#include <string>
#include "platform.h"

#pragma pack(push,1)
namespace framework
{
	namespace unity
	{
		template<class EnumT, typename EnumT value>
		class IEnumRTTI
		{
		public:
			IEnumRTTI()
			{
				mEnumType = value;
			}
			virtual ~IEnumRTTI(){}

			virtual EnumT eType(){ return mEnumType; }

		private:
			EnumT mEnumType;
		};
		/*
		ʹַΪģʱҪע¼:
		1 template<class T, const char value[]>вҪʹconst char* ͡
		2ڽģʵʱĲҪʹextern extern const char externValue[];
		3дڡ.hļģҪֱextern const char externValue[] = "value";
			ͷļֻCPPдʵ֣const char externValue[] = "value";
		֮ܶʹַģ̫󣬺д뷨
		תʹù̶ģԽʡʹchar*4ֽڿ
		*/
		class IAsciiRTTI
		{
		public:
			IAsciiRTTI(const char* type)
			{
				size_t length = strlen(type);
				mStrType = new char[length+1];
				memcpy(mStrType, type, length * sizeof(char));
				mStrType[length] = '\0';
			}
			virtual ~IAsciiRTTI()
			{
				delete []mStrType;
			}
			virtual const char* sType(){ return mStrType; }

		private:
			char* mStrType;
		};
		// ʡڴַ̬
		template<typename const size_t length>
		class IAsciiFixedRTTI
		{
		public:
			IAsciiFixedRTTI(const char* type)
			{
				memcpy(mStrType, type, length * sizeof(char));
				mStrType[length] = '\0';
			}
			virtual ~IAsciiFixedRTTI(){}
			virtual const char* sType(){ return mStrType; }

		private:
			char mStrType[length+1];
		};
	}	// namespace unity
}	// namespace framework

#define MAKER_ENUM1BTRTTI_TYPE(type) framework::unity::IEnumRTTI<uint8, type>
#define MAKER_ENUM2BTRTTI_TYPE(type) framework::unity::IEnumRTTI<uint16, type>
#define MAKER_ENUM4BTRTTI_TYPE(type) framework::unity::IEnumRTTI<uint32, type>
#define MAKER_ASCIIFIXEDRTTI_TYPE(len) framework::unity::IAsciiFixedRTTI<len>

#pragma pack(pop)
